mod Ex09a

incl Mtex

incl Mtexnt

incl Mauxa

loc rem 
  \para \bf  9. CVICENIE Z PREDMETU 1-INF-465 DEKLARATIVNE PROGRAMOVANIE  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end utorok 15.4.2008 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-INF-465-dp/0708ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Uvodna poznamka.  \end Toto cvicenie je venovane numerickym termom 
  a Braunovym stromom. Zadanie sa sklada z tychto suborov: 
  \items 
   \item \para Subory \it  mtex*.cl  \end obsahuju makra pre CL-TeX. 
   \item \para Subory \it  maux*.cl  \end obsahuju definicie niektorych funkcii 
         a predikatov. 
   \item \para Subory \it  ex*.cl  \end obsahuju ulohy, ktore mate riesit na 
         tomto cviceni. 
  \end
  \para Tieto subory sa musia skompilovat v spravnom poradi; presny postup je 
  uvedeny v subore \it  readme.txt  \end. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara and P. J. Voda. Metamathematics of 
         Computer Programming. 2001. 
  \end

rem 
  \para \bf  [CL] Remark.  \end The module \it  Msyntax  \end in the file \it  
  msyntax.cl  \end contains the syntax of the system CL. 

rem 
  \para \bf  Chapter. Programs Operating on Symbolic Expressions.  \end 

rem 
  \para \bf  Section. Numeric Terms.  \end 

rem 
  \para \bf  Subsection. Arithmetization of Numeric Terms.  \end 

rem 
  \para \bf  Constructors of numeric terms.  \end 

fun Vt 'Tex_f1_nt_vt'
  Vt(i) = 0,i

fun Ct 'Tex_f1_nt_ct'
  Ct(n) = 1,n

fun/2 At 'Tex_f2_nt_at'
  At(t1,t2) = 2,t1,t2

fun/2 Mt 'Tex_f2_nt_mt'
  Mt(t1,t2) = 3,t1,t2

rem 
  \para \bf  [CL] Discrimination on the constructors of numeric terms.  \end 
  Example(s): 
  \def 
    fun F 'Tex_f1_f'
    F Vt(i) = Foo
    F Ct(n) = Foo
    F At(t1,t2) = Foo
    F Mt(t1,t2) = Foo
  \end

rem 
  \para \bf  Numeric terms.  \end 

pred Term 
  Term Vt(i) <- N(i)
  Term Ct(n) <- N(n)
  Term At(t1,t2) <- Term(t1) & Term(t2)
  Term Mt(t1,t2) <- Term(t1) & Term(t2)

rem 
  \para \bf  [CL] Formatting the output.  \end Use the format \ft Term \end to 
  display numbers as numeric terms. Try out the following simple queries 
  \verbatim 
     98041654 = t:Term
  \end
  \verbatim 
     3,(2,(0,1),1,2),0,3 = t:Term
  \end

rem 
  \para \bf  Subsection. Basic Operations and Predicates.  \end 

rem 
  \para \bf  Size of numeric terms.  \end 

fun Sz 'Tex_f1_nt_sz'
  Sz(t) = Foo

rem 
  \para \bf  Denotation of numeric terms.  \end 

fun/2 Den 'Tex_f2_nt_den'
  Den(t,v) = Foo

rem 
  \para \bf  Subsection. Postfix Machine.  \end 

rem 
  \para \bf  Instructions.  \end 

fun Vi 'Tex_f1_nt_vi'
  Vi(i) = 0,i

fun Ci 'Tex_f1_nt_ci'
  Ci(n) = 1,n

fun/0 Ai 'Tex_f0_nt_ai'
  Ai = 2,0

fun/0 Mi 'Tex_f0_nt_mi'
  Mi = 3,0

pred Instr 
  Instr Vi(i) <- N(i)
  Instr Ci(n) <- N(n)
  Instr(Ai)
  Instr(Mi)

rem 
  \para \bf  Programs.  \end 

pred Program 
  Program(p) <-> Poo

rem 
  \para \bf  Compilation.  \end 

fun Cmp 
  Cmp(t) = Foo

rem 
  \para \bf  One-step evaluation.  \end \header* fun/3 Run  \end Define the 
  function \ft Run(p,v,s) \end such that 
  \eq* 
    Run(0,v,t,0) = t
  \end
  \eq* 
    Term(t) -> Run(Cmp(t)++p,v,s) = Run(p,v,Den(t,v),s)
  \end
  \para Note that we then have 
  \eq* 
    Term(t) -> Den(t,v) = Run(Cmp(t),v,0)
  \end

fun/3 Run 
  Run(p,v,s) = Foo

rem 
  \para \bf  Subsection. Additional Problems.  \end 

rem 
  \para \bf  Terms with left associated addition.  \end 

pred Lassoc 
  Lassoc Vt(i)
  Lassoc Ct(n)
  Lassoc At(t,Vt(i)) <- Lassoc(t)
  Lassoc At(t,Ct(n)) <- Lassoc(t)
  Lassoc At(t,Mt(t1,t2)) <- Lassoc(t)
  Lassoc Mt(t1,t2)

rem 
  \para \bf  Rearranging terms into expressions with left associated addition. 
   \end \header* fun T2l 'Tex_f1_f' \end Define the function \ft T2l(t) \end 
  such that 
  \eq* 
    Term(t) -> Term T2l(t)
  \end
  \eq* 
    Term(t) -> Lassoc T2l(t)
  \end
  \eq* 
    Term(t) -> Den(T2l(t),v) = Den(t,v)
  \end
  \eq* 
    Term(t) -> Sz T2l(t) = Sz(t)
  \end

fun T2l 'Tex_f1_f'
  T2l(t) = Foo

